# Video Creative Management (V3)

V3.0 video creative management endpoints

## Bulk create video creatives

 - [PUT /v3.0/creatives/bulk](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/put_v3-0-creatives-bulk.md): Create a set of video creatives (bulk upload) - V3

## Bulk update video creatives

 - [PATCH /v3.0/creatives/bulk](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/patch_v3-0-creatives-bulk.md): Update a set of video creatives (bulk update) - V3

## Create a new video creative

 - [POST /v3.0/creatives](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/post_v3-0-creatives.md): Create a new video creative - V3.

### Uploading a video file

To upload a video, supply the fileName field in the request body
(see the Create with fileName sample in the Request samples panel).
The response then includes a pre-signed S3 uploadUrl (valid for
expiresIn seconds), which the client uses to PUT the file directly to S3:

bash
curl -X PUT \
    -H "x-amz-acl: public-read" \
    -H "x-amz-meta-creative: {{CREATIVE_ID}}" \
    -H "Content-Type: {{UPLOADED_FILE_CONTENT_TYPE}}" \
    --upload-file "{{UPLOADED_FILE_PATH/File.mp4}}" \
    "{{S3_PRESIGNED_URL}}"


The x-amz-acl: public-read and x-amz-meta-creative:  headers
are required (both are signed into the pre-signed URL).

## Bulk get creatives by IDs

 - [POST /v3.0/creatives/list](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/post_v3-0-creatives-list.md): Retrieve multiple video creatives by their IDs

## Get creative details

 - [GET /v3.0/creatives/{creativeId}](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/get_v3-0-creatives-creativeid.md): Get status/details for the video creative - V3

## Update video creative (full update)

 - [POST /v3.0/creatives/{creativeId}](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/post_v3-0-creatives-creativeid.md): Update the video creative - must post all data, any omitted fields will be removed

## Update video creative (partial update)

 - [PATCH /v3.0/creatives/{creativeId}](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/patch_v3-0-creatives-creativeid.md): Allows partial updates to a video creative - V3

## Validate VAST XML - V3

 - [POST /v3.0/creatives/validateVAST](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/post_v3-0-creatives-validatevast.md): Validates the provided VAST XML content and returns any errors or warnings.

## List history for a creative - V3

 - [GET /v3.0/creatives/{creativeId}/history](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/get_v3-0-creatives-creativeid-history.md): List history for a creative

## Delete history entry for creative - V3

 - [DELETE /v3.0/creatives/{creativeId}/history](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/delete_v3-0-creatives-creativeid-history.md): Delete history entry for creative

## Create companion ad - V3

 - [POST /v3.0/creatives/{creativeId}/companions](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/post_v3-0-creatives-creativeid-companions.md): Post new companion details and receive the new companion ID.
Regenerates the creative's MetaVAST document after the companion is created.

## Get all companions - V3

 - [GET /v3.0/creatives/{creativeId}/companions](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/get_v3-0-creatives-creativeid-companions.md): Get all companion ads for the creative.

## Get specific companion - V3

 - [GET /v3.0/creatives/{creativeId}/companions/{companionId}](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/get_v3-0-creatives-creativeid-companions-companionid.md): Get a specific companion ad for the creative.

## Update companion - V3

 - [POST /v3.0/creatives/{creativeId}/companions/{companionId}](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/post_v3-0-creatives-creativeid-companions-companionid.md): Update an existing companion's details.
Regenerates the creative's MetaVAST document after the companion is updated.

## Delete companion - V3

 - [DELETE /v3.0/creatives/{creativeId}/companions/{companionId}](https://apidocs.mediamath.com/apis/video-creatives/video-creative-management-(v3)/delete_v3-0-creatives-creativeid-companions-companionid.md): Delete a companion from the creative.
Regenerates the creative's MetaVAST document after the companion is deleted.

